io.stdout:setvbuf("no")
love.graphics.setDefaultFilter("nearest", "nearest")

--[[ modules ]]--
	require("sub")
	require("src.player.player")
	require("src.player.camera")

	require("src.tiles")

	require("src.mapIO.mapIO")

--[[ variables ]]--
	xymod = {
		["isometric"] = cartToIso,
		["isoToCart"] = isoToCart
	}

	collision = {
		["isometric"] = mapIO["isometric"].checkCollision
	}

--[[ functions ]]--
	mapIO:load("test")
	player:spawn(0, 0, 0, 0)

function love.update(dt)
	player:update(dt)
	mapIO:update(dt)
	camera:update()
end

function love.draw()
	love.graphics.push()
	love.graphics.scale(camera.scale)
	love.graphics.translate(-camera.x, -camera.y)
	mapIO:draw()
	player:draw()
	love.graphics.pop()
	love.graphics.print(love.timer.getFPS())
end