iso = {}

function cartToIso(cartX, cartY)
	local isoX = cartX - cartY
	local isoY = (cartX + cartY) / 2
	return isoX, isoY
end

function isoToCart(isoX, isoY)
	local cartX = (2 * isoY + isoX) / 2
	local cartY = (2 * isoY - isoX) / 2
	return cartX, cartY
end

function mapToIso(pos)
	local cartY = math.ceil(pos / mapIO.map.layers[1].width - 1)
	local cartX = pos - cartY * mapIO.map.layers[1].width - 1
	return cartToIso(cartX, cartY)
end

function cartToMap(cartX, cartY)
	return -(-cartX - cartY * mapIO.map.layers[1].width - 1)
end

function isoToPixel(isoX, isoY)
	return isoX * mapIO.map.tilesets[1].tileheight, isoY * mapIO.map.tilesets[1].tileheight
end

function iso:load()
	mapIO.mapImg = love.graphics.newSpriteBatch(atlas[mapIO.map.tilesets[1].name], 3000, "dynamic")

	self.mapData = {}
	for layer = 1, #mapIO.map.layers do
		for pos = 1, mapIO.map.layers[layer].width * mapIO.map.layers[layer].height do
			local id = mapIO.map.layers[layer].data[pos]
			if id ~= 0 then
				-- x, y, z koordinaten werden in iso und prozent anzahl gespeichert
				x, y = mapToIso(pos)
				z = (layer - 1) / 2
				table.insert(self.mapData, {id = id, x = x, y = y, z = z})
			end
		end
	end
end

function iso:update(dt)
	print(id)
	table.sort(self.mapData, function(a, b) return a.y < b.y or a.z < b.z end)
end

function iso:draw()
	mapIO.mapImg:clear()

	-- for pos = 1, mapIO.map.layers[1].width * mapIO.map.layers[1].height do
	-- 	if id ~= 0 then
	-- 		-- layer 1
	-- 		mapIO.mapImg:add(tiles[mapIO.map.layers[1].data[pos]].img, isoToPixel(mapToIso(pos)))
	-- 	end
	-- end

	for i = 1, #self.mapData do
		local x, y = isoToPixel(self.mapData[i].x, self.mapData[i].y)
		print(self.mapData[i].id)
		mapIO.mapImg:add(tiles[self.mapData[i].id].img, x, y)
	end

	love.graphics.setColor(255, 255, 255)
	local x, y = xymod[mapIO.map.orientation](player.x, player.y)
	love.graphics.draw(mapIO.mapImg, -x, -y)
end

return iso